package es.verdnatura.presentation.view.feature.boxPicking

import android.content.Context
import androidx.lifecycle.LiveData
import androidx.lifecycle.MutableLiveData
import es.verdnatura.domain.SalixCallback
import es.verdnatura.presentation.base.BaseViewModel
import retrofit2.Response

class BoxPickingViewModel(val context: Context) : BaseViewModel(context) {

    private val _isBoxPickingInPrintOut by lazy { MutableLiveData<Boolean>() }
    val isBoxPickingInPrintOut: LiveData<Boolean> = _isBoxPickingInPrintOut

    private val _responseCode by lazy { MutableLiveData<String>() }
    val responseCode: LiveData<String> = _responseCode
    fun isBoxPickingOk(
        expeditionFk: Long, itemFk: Long

    ) {
        salix.isBoxPickingInPrintOut(
            filter = """{"where":{"expeditionFk":$expeditionFk,"itemFk":$itemFk}}"""
        ).enqueue(object : SalixCallback<Any>(context) {

            override fun onSuccess(response: Response<Any>) {

                _isBoxPickingInPrintOut.value = true
            }

            override fun onError(t: Throwable) {

                _isBoxPickingInPrintOut.value = false
            }
        })
    }

    fun isBoxPickingInPrintOut(expeditionFk: Long, barcode: String) {
        salix.barcodesToItem(barcode).enqueue(object : SalixCallback<Int?>(context) {

            override fun onSuccess(response: Response<Int?>) {

                if (response.body() != null) {
                    isBoxPickingOk(
                        itemFk = response.body().toString().toLong(),
                        expeditionFk = expeditionFk
                    )
                } else {
                    _isBoxPickingInPrintOut.value = false
                }

            }
        })
    }

}