package es.verdnatura.presentation.view.feature.main.activity

import android.content.Context
import androidx.lifecycle.LiveData
import androidx.lifecycle.MutableLiveData
import es.verdnatura.domain.SalixCallback
import es.verdnatura.presentation.base.BaseViewModel
import es.verdnatura.presentation.common.ResponseItemVO
import es.verdnatura.presentation.view.feature.main.model.WorkerActionSalix
import retrofit2.Response

class MainActivityViewModel(var context: Context) : BaseViewModel(context) {

    private val _response by lazy { MutableLiveData<ResponseItemVO>() }
    val inventaryList: LiveData<ResponseItemVO>
        get() = _response

    fun workerActivityAdd(
        workerActionSalix: WorkerActionSalix
    ) {

        salix.workerActivityAdd(workerActionSalix)
            .enqueue(object : SalixCallback<Any>(context) {
                override fun onSuccess(response: Response<Any>) {
                    _response.value = ResponseItemVO(isError = false, response = response.message())
                }
            })
    }

    fun workerActivityList(
    ) {

        salix.workerActivityList()
            .enqueue(object : SalixCallback<Any>(context) {
                override fun onSuccess(response: Response<Any>) {
                    _response.value = ResponseItemVO(isError = false, response = response.message())
                }
            })
    }

}



